; mk_sprt for prowess sprite designer

	section	text
	xdef	mksprt

	xref	gu_achp
	xref	rt_fp
	xref	gu_rchp
; V. 1.00
;  W. Lenerz 1996

* address = MK_SPRT (sprite$,x_columns%,[,xo%,yo%])
; this makes the entire sprite, returns address of sprite.
; the address is as used by PROforma, so the sprite actually
; lies at address+60
*
; ATTENTION
; 1 - this only works in SBASIC or compiled Basic, NOT in SuperBasic
* 2 - it is assumed that sizeof(FileInfo) = 60

mksprt	MOVEQ	#0,D7		; assume origin = 0,0
	MOVE.L	A5,D0
	SUB.L	A3,D0
	SUB.L	#16,D0		; only two params?
	BEQ.S	no_origs		; yes->...
	SUB.L	#16,D0		; there must be two more, then
	BNE	err_bp		; oops!->...
	LEA	16(A3),A3 	; point past string & nbrcols parameters
	MOVE.W	$112,A2
	JSR	(A2)		; get ints
	BNE	out		; oops->...
	SUBQ.W	#2,D3		; there must be 2
	BNE	err_bp		; but there aren't ->...
	MOVE.L	(A6,A1.L),D7	; D7= x,y origins
	ADDQ.L	#4,$58(A6)	; reset maths stack now
	LEA	-16(A3),A3	; point to string array again

no_origs	ADDQ.L	#8,A3
	LEA	8(A3),A5		; isolate nbrcols parameter
	MOVE.W	$112,A2
	JSR	(A2)		; get int
	BNE	out		; oops->...
	SUBQ.W	#1,D3		; there must be exactly 1
	BNE	err_bp		; but there isn't ->...
	ADDQ.L	#2,$58(A6)	; reset maths stack now
	MOVE.W	(A6,A1.L),D6	; D6= x size (nbr of columns)
	BEQ	err_bp		; there must be at least one column!
	SUBQ.L	#8,A3		; point to string array parameter
	MOVE.W	(A6,A3.L),D1	; D1 = type of parameter
	ANDI.W	#$F0F,D1		; eliminate unwanted bits
	SUB.W	#$301,D1		; is it a string array?
	BNE	err_bp		; no, so error ->...
	MOVE.L	4(A6,A3.L),D1	; D1=pointer to array descriptor
	BMI	err_bp		; if neg(=undefined): error bad par
	MOVE.L	D1,A4		; keep this in A4 (for later)
	CMP.W	#2,4(A4)		; there must be 2 dims
	BNE.S	err_bp		; else error->...
	MOVEQ	#0,D5		; this will contain number of rows (y)

	MOVE.W	6(A4),D5		; number of rows
	BLE.S	 err_bp		; there must be at least one!
	ADDQ.W	#1,D5		; true number of rows, starting at 0

	MOVEQ	#15,D0		; now make number of pixels per line:
	ADD.W	D6,D0		; nbr of columns= x size...
	AND.W	#$FFF0,D0 	; ... rounded up to nearest 16 (sprite data is always word sized)
	MOVE.L	D0,D3		; keep this for later (pixels per line)
	LSR.W	#1,D0		; 16 pixels take 8 bytes
	MULU	D5,D0		; times number of rows = mem needed
	ADD.L	#24+60+4,D0	; there's a 24-byte header for sprite..
				; ... and 60 bytes for proforma...
	JSR	gu_achp		; and 4 bytes for the link
	TST.L	D0		; got mem ok?
	BNE.S	out		; no->...

	LEA	$E0(A6),A1	; pointer to our link
	MOVE.W	$D2,A2
	JSR	(A2)		; link this into ALCHP heap
	ADDQ.L	#4,A0		; cut out linkage area, so that RECHP...
				; ...works ok later
	LEA	60(A0),A1 	; A1 points start of sprite, past FileInfo
	MOVE.L	#$01000000,(A1)+	; form (QL mode 4, no time, no adaption)
	MOVE.W	D6,(A1)+		; xsize
	MOVE.W	D5,(A1)+		; ysize
	MOVE.L	D7,(A1)+		; x,y origins
	MOVE.L	#12,(A1)+ 	; pointer to colour pattern (this follows right after...)
	MOVE.L	D3,D0		; pixels perline
	ASR.W	#2,D0		; nearest long word
	MULU	D5,D0		; * nbr of rows
	ADDQ.L	#8,D0		; offset
	MOVE.L	A1,A2		; start of sprite
	MOVE.L	D0,(A1)+		; pointer to pattern mask
	ADD.L	D0,A2		; A2 now points to start of pattern mask
	MOVE.L	#0,(A1)+		; no pointer to next sprite (!)
	LEA	mode_4,A5 	; point to table for chars - mode 4
	SWAP	D5		; D5.H = nbr of rows
	MOVE.L	(A4),A4		; point to data now
	ADDQ.L	#2,A4

	BSR.S	nxt_line		; fill in sprite line by line until no more lines
	BNE.S	oops		; the name says it all...
	MOVE.L	A0,D2		; address in D2:...
	JMP	rt_fp		; return as float now
oops	SUBQ.L	#4,A0
	JMP	gu_rchp		; ... release mem & return with error

err_bp	MOVEQ	#-15,D0		; error 'Bad parameter'
out	TST.L	D0
	RTS

; sprite data is always a mulpiple of 16 bytes (1 word)
; if this is too big for a sprite, the data is filled in with 'unreal'
; pixels,i.e transparent ones
;
; A1 = space for the colour pattern for the sprite
; A2 = start of pattern mask
; A4 = start of array data
; A5 = pointer to table
; D3 = pixels per line, including 'unreal' pixels
; D5.H = number of rows (y) (during use, D5.l = D3)
; D6 = number of chars per row

new_word	MOVE.W	(A5),D2		; initial mask (shifted for each pixel)
do_word	SUB.L	#1,D5		; one character fewer (also decerases lines!)
	TST.W	D5		; any (real or unreal) pixels left?
	BMI.S	end_line		; no, end of this line

	MOVEQ	#' ',D1		; preset "unreal" pixel (transparent)
	SUBQ.W	#1,D7		; any real pixels left?
	BMI.S	no_real		; no, use transparent->...
	MOVE.B	(A4)+,D1		; get a character
	OR.B	#$20,D1		; make into lower case

no_real	MOVE.W	D2,D0		; get pixel mask - which pixel are...
	NOT.W	D0		; we using?
	AND.W	D0,(A1)		; blank existing colour pattern...
	AND.W	D0,(A2)		; ... and pattern mask
	MOVEQ	#4,D0		; there are 4 valid characters

fnd_char	CMP.B	char_tbl(PC,D0.W),D1 ; look for character in table
	DBEQ	D0,fnd_char	; with loop
	BNE.S	err_bp		; hey??? char not found ->...
	ADD.W	D0,D0		; offset in word_sized colour table
	BEQ.S	nxt_pixl		; it's transparent, no more work to do
	MOVE.W	2(A5,D0.W),D0	; get colour pattern for this char
	AND.W	D2,D0		; mask out all but current pixel
	OR.W	D0,(A1)		; set pattern...
	OR.W	D2,(A2)		; ... and mask

nxt_pixl	LSR.W	#1,D2		; shift mask for next pixel (would be 2 for mode 8)
	BCC.S	do_word		; this word not finished yet
	CMP.W	(A1)+,(A2)+	; increment pattern and mask pointers (!)
	BRA.S	new_word		; and do next bit of line

end_line	MOVE.L	A4,D0		; make sure A4 points to next line, if..
	ADDQ.L	#3,D0		; ...line was padded because of odd ...
	BCLR	#0,D0		; ... nbr of chars, and point after...
	MOVE.L	D0,A4		; ... length word!

nxt_line	MOVEQ	#0,D0		; signal no error
	MOVE.W	D0,D5		; no pixels yet (& make sure test is ok)
	TST.L	D5		; any more lines left?
	BEQ.S	out		; no, leave w/o error ->...
	MOVE.W	D3,D5		; yes, number of pixels to set in line
	MOVE.W	D6,D7		; a line has this many characters
	BRA.S	new_word


char_tbl	 DC.B	 ' argw'		 ; possible colours in mode 4


mode_4	DC.W	%1000000010000000	; initial pixel mask
	DC.W	'WL'		; ' '
	DC.W	$0000		; a
	DC.W	$00FF		; r
	DC.W	$FF00		; g
	DC.W	$FFFF		; w

	END
