; this is the PWquery keyword for the Prowess Sbasic interface
; v. 1.01       1996 May 19 17:02:26
;  copyright (c) W. Lenerz 1996
; also containe PWcolourquery



*************************************************************************
*
* This is the PWquery keyword
*
* syntax: result=PWquery(object, what)
*
* where:	object is the object to query
*	what is the query tag
*	result is the result that will be returned
***************************************************************************

	section	text

	xdef	pwquery
	xdef	pwquery2
	xdef	pwcolourquery
	include	asm_includes_asm

	xref	_pwquery
	xref	gmem		; get mem in my format (prowess_asm_gmem)
	xref	get_all2		; get params & push onto stack (prowess_asm_getparams)
	xref	get_long		; (same)
	xref	gu_rchp		; release common heap mem (gu_rechp)
	xref	rt_fp		; return fp to basic (lib_returnparams)
	xref	err_out		; reset stack, rel mem & rts with error (prowess_asm_pwactivate)
	xref	e_o		; rel mem & rts with error (prowess_asm_pwactivate)
	xref	rt_str
	xref	rt_int

pwquery	BSR	gmem		;
	MOVE.L	#0,-(A4)		; NULL
	MOVE.L	A0,-(A4)		; pointer for return param
	ADDQ.L	#4,A0		; pointer after this parameter
	BSR	get_all2		; push parameters onto stack
	BNE	e_o
pwquery2	MOVE.L	A4,A7		; new stack pointer
	BSR	_pwquery		; do it
	TST.L	D0		; did call go ok?
	BNE	err_out		; no->...
	MOVE.L	4(A4),D4		; what part of the query
	reset_stk
		; get my stack back

; now see whether this is one of the 3 cases where a string is returned
; directly
	CMP.L	#PW_DEFAULT_FONT,D4 ; these three tags return direct strings
	BEQ.S	ret_str		; it is->...
	CMP.L	#PW_FILESELECT_DIRECTORY,D4
	BEQ.S	ret_str		; it is->...
	CMP.L	#PW_FILESELECT_FILENAME,D4
	BEQ.S	ret_str		; it is->...
	MOVE.L	4(A0),D2		; return parameter
	BSR	gu_rchp		; release mem
	BRA	rt_fp		; return float in D2 to basic
ret_str	LEA	4(A0),A2		; point to string
	MOVEQ	#0,D4		; future length of string
	MOVE.L	A2,A3		; keep
loop	TST.B	(A2)+		; end of string?
	BEQ.S	end_str		; loop until end of string
	ADDQ.W	#1,D4		; adjust length of string
	BRA.S	loop
end_str	BSR	rt_str		; put string on maths stack
	BSR	gu_rchp		; now release mem (!)
	MOVE.L	$58(A6),A1
	MOVEQ	#1,D4
	MOVEQ	#0,D0
	RTS			; return string to basic


*************************************************************************
*
* This is the PWcolourquery keyword
*
* syntax: PWquery object, what, r,g,b
*
* where:	object is the object to query
*	what is the query tag (one of the colour query tags)
*	r,g,b, returned result, r,g,b, colour values
*
* v. 1.01 1999 Sep 17 12:38:16
***************************************************************************


; PWcolourquery outl,tag,r,g,b
pwcolourquery
	BSR	gmem		;
	MOVE.L	#0,-(A4)		; NULL
	MOVE.L	A0,-(A4)		; pointer for return param
	ADDQ.L	#4,A0		; pointer after this parameter
	LEA	16(A3),A5
	BSR	get_all2		; push parameters onto stack
	bne	e_o
	MOVE.L	A4,A7		; new stack pointer
	BSR	_pwquery		; do it
	TST.L	D0		; did call go ok?
	BNE	err_out		; no->...
	reset_stk
	LEA	16(A3),A3
	MOVE.L	A0,A4
	MOVEQ	#0,D2
	MOVE.W	4(A4),D2
	BSR	rt_fp		; put int value on stack
	MOVE.W	$120,A0
	JSR	(A0)		; and return it
	ADDQ.L	#8,A3		; pont next param
	MOVEQ	#0,D2
	MOVE.W	8(A4),D2
	BSR	rt_fp		; put int value on stack
	MOVE.W	$120,A0
	JSR	(A0)
	ADDQ.L	#8,A3		; point next param
	MOVEQ	#0,D2
	MOVE.W	12(A4),D2
	BSR	rt_fp		; put int value on stack
	MOVE.W	$120,A0
	JSR	(A0)
	MOVE.L	A4,A0
	BRA	gu_rchp		; rel mem & return


	END
